org.apache.ignite.internal.processors.cache

## Class IgniteCacheOffheapManagerImpl.PendingEntriesTree

- java.lang.Object
- - org.apache.ignite.internal.processors.cache.persistence.DataStructure
  - - org.apache.ignite.internal.processors.cache.persistence.tree.BPlusTree<org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow,org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow>
    - - org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingEntriesTree

All Implemented Interfaces:
  PageLockListener, IgniteTree<org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow,org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow>

Enclosing class:
  IgniteCacheOffheapManagerImpl

    protected static class IgniteCacheOffheapManagerImpl.PendingEntriesTree
    extends BPlusTree<org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow,org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow>

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.ignite.internal.processors.cache.persistence.tree.BPlusTree

`BPlusTree.DestroyBag`

### Nested classes/interfaces inherited from interface org.apache.ignite.internal.util.IgniteTree

`IgniteTree.InvokeClosure<T>, IgniteTree.OperationType`

### Field Summary

### Fields inherited from class org.apache.ignite.internal.processors.cache.persistence.tree.BPlusTree

`metaPageId`

### Fields inherited from class org.apache.ignite.internal.processors.cache.persistence.DataStructure

`grpId, pageMem, reuseList, rnd, wal`

### Constructor Summary

Constructors
Constructor and Description
`IgniteCacheOffheapManagerImpl.PendingEntriesTree(CacheGroupContext grp, String name, PageMemory pageMem, long metaPageId, ReuseList reuseList, boolean initNew)`

### Method Summary

Methods
`protected int` `compare(BPlusIO<org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow> iox, long pageAddr, int idx, org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow row)`
`protected org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow` `getRow(BPlusIO<org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow> io, long pageAddr, int idx, Object flag)` Get data row.

### Methods inherited from class org.apache.ignite.internal.processors.cache.persistence.tree.BPlusTree

`compare, destroy, destroy, find, find, findFirst, findLast, findOne, findOne, getFirstPageIds, getName, getRow, initTree, initTree, interruptAll, invoke, latestInnerIO, latestLeafIO, printTree, put, putx, remove, removex, rootLevel, setIos, size, toString, treeName, validateTree`

### Methods inherited from class org.apache.ignite.internal.processors.cache.persistence.DataStructure

`acquirePage, allocatePage, allocatePageNoReuse, groupId, init, needWalDeltaRecord, onBeforeReadLock, onBeforeWriteLock, onReadLock, onReadUnlock, onWriteLock, onWriteUnlock, pageSize, randomInt, read, read, readLock, readUnlock, recyclePage, releasePage, tryWriteLock, write, write, write, write, writeLock, writeUnlock, writeUnlock`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### IgniteCacheOffheapManagerImpl.PendingEntriesTree

    public IgniteCacheOffheapManagerImpl.PendingEntriesTree(CacheGroupContext grp,
                                                    String name,
                                                    PageMemory pageMem,
                                                    long metaPageId,
                                                    ReuseList reuseList,
                                                    boolean initNew)
                                                     throws IgniteCheckedException

Parameters:
  `grp` - Cache group.
  `name` - Tree name.
  `pageMem` - Page memory.
  `metaPageId` - Meta page ID.
  `reuseList` - Reuse list.
  `initNew` - Initialize new index.
Throws:
  `IgniteCheckedException` - If failed.

### Method Detail

#### compare

    protected int compare(BPlusIO<org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow> iox,
              long pageAddr,
              int idx,
              org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow row)
                   throws IgniteCheckedException

Specified by:
  `compare` in class `BPlusTree<org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow,org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow>`
Parameters:
  `iox` - IO.
  `pageAddr` - Page address.
  `idx` - Index of row in the given buffer.
  `row` - Lookup row.
Returns:
  Comparison result as in `Comparator.compare(Object, Object)`.
Throws:
  `IgniteCheckedException` - If failed.

#### getRow

    protected org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow getRow(BPlusIO<org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow> io,
                                                                                              long pageAddr,
                                                                                              int idx,
                                                                                              Object flag)
                                                                                                   throws IgniteCheckedException

Get data row. Can be called on inner page only if `BPlusTree.canGetRowFromInner` is `true`.

Specified by:
  `getRow` in class `BPlusTree<org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow,org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl.PendingRow>`
Parameters:
  `io` - IO.
  `pageAddr` - Page address.
  `idx` - Index.
  `flag` - Implementation specific argument, `null` always means that we need to return full detached data row.
Returns:
  Data row.
Throws:
  `IgniteCheckedException` - If failed.

2017 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 2.1.0
Release Date | : July 20 2017